﻿using System;
using System.IO;
using System.Net.Sockets;

namespace EchoTcpServerWithHelper
{
    class ConnectionHandler
    {
        private readonly TcpClient _client;
        public ConnectionHandler(TcpClient client)
        {
            _client = client;
        }

        public void DoIt()
        {
            try
            {
                NetworkStream stream = _client.GetStream();
                StreamReader reader = new StreamReader(stream);
                string request = reader.ReadLine(); // echo is a line based protocol
                string response = request; // this is echo!
                StreamWriter writer = new StreamWriter(stream);
                writer.WriteLine(response);
                writer.Flush();
                //byte[] receiveBuffer = new byte[1024];
                //int howManyBytes = stream.Read(receiveBuffer, 0, receiveBuffer.Length);
                //String message = Encoding.ASCII.GetString(receiveBuffer, 0, howManyBytes);
                //Console.WriteLine(message + " received from " + client.Client.RemoteEndPoint);
                //byte[] sendBuffer = Encoding.ASCII.GetBytes(message + "\n");
                //stream.Write(sendBuffer, 0, sendBuffer.Length);
            }
            catch (IOException ex)
            {
                Console.Error.WriteLine(ex.Message);
            }
            finally
            {
                _client.Close();
            }
        }
    }
}
